<script setup lang="ts">
import { useReceiptStore } from '@/stores/receipt'
import { usePromotionStore } from '@/stores/promotion'

import { onMounted, provide } from 'vue'
import { ref } from 'vue'
import type { Promotion } from '@/types/Promotion'
import { watch } from 'vue'
import { useAuthStore } from '@/stores/auth'
import { useBranchStore } from '@/stores/branch'
import { useUserStore } from '@/stores/user'
import Swal from 'sweetalert2'

const receiptStore = useReceiptStore()
const promotionStore = usePromotionStore()
const UserStore = useUserStore()
const branchStore = useBranchStore()
const authStore = useAuthStore()
const promotionName = ref('')
const cashText = ref()
const dialogCash = ref(false)
const editedBranchId = receiptStore.editedReceipt.branch
  ? receiptStore.editedReceipt.branch.id
  : null

function calChange() {
  const paInt = (cashText.value = parseInt(cashText.value, 10))
  let cash = (receiptStore.editedReceipt.receivedAmount = paInt)
  let total = receiptStore.editedReceipt.total
  if (cash >= total) {
    receiptStore.editedReceipt.change = cash - total
  } else {
    receiptStore.editedReceipt.receivedAmount = 0
    receiptStore.editedReceipt.change = 0
    // dialogCash.value = !dialogCash.value
    Swal.fire({
      icon: 'warning',
      title: 'Warning',
      text: 'Cash is Lower Than Total!'
    })
  }
  clearTxtField()
}

function validateNumber(value: any) {
  const isValid = /^\d+$/.test(value)
  return isValid || 'Please enter a number'
}

function promptpay() {
  const a = (receiptStore.editedReceipt.paymentType = 'Promptpay')
  console.log(a)
  receiptStore.editedReceipt.receivedAmount = receiptStore.editedReceipt.total
  receiptStore.editedReceipt.change = 0
}

function cashPay() {
  receiptStore.editedReceipt.receivedAmount = 0
  const a = (receiptStore.editedReceipt.paymentType = 'Cash')
  console.log(a)
}

function clearTxtField() {
  cashText.value = '0'
}

function btnNotShow() {
  if (receiptStore.receiptItems.length < 1) {
    return true
  } else {
    return false
  }
}

onMounted(() => {
  branchStore.getBranchs()
  promotionStore.getPromotions()
})
</script>

<template>
  <v-container>
    <v-row>
      <v-col justify="center">
        <v-row no-gutters>
          <v-col cols="6">Subtotal:</v-col
          ><v-col cols="6">{{ receiptStore.editedReceipt?.total_before }} ฿</v-col>
          <v-col cols="6">Member Discount:</v-col
          ><v-col cols="6">{{ receiptStore.editedReceipt.member_discount }} ฿</v-col>
          <v-col cols="3">Promotion:</v-col>
          <v-col cols="9" v-if="promotionStore.promotionCurrent">{{
            promotionStore.promotionCurrent.map((detail: Promotion) => detail.name).join(', ')
          }}</v-col>
          <v-col cols="7" v-else></v-col>

          <v-col cols="6">Promotion Discount:</v-col
          ><v-col cols="6" v-if="promotionStore.promotionCurrent"
            >{{ receiptStore.editedReceipt.promotion_discount }} ฿</v-col
          >
          <v-col cols="6" v-else>0.00 ฿</v-col>
          <v-col cols="6" style="font-size: 20px; font-weight: bold">Total:</v-col
          ><v-col cols="6" style="font-size: 20px; font-weight: bold"
            >{{ receiptStore.editedReceipt?.total }} ฿</v-col
          >
        </v-row>
      </v-col>
      <v-divider :thickness="2" class="border-opacity-100" vertical></v-divider>
      <v-col v-if="receiptStore.isEmp()">
        <v-row class="align-center" no-gutters>
          <v-col cols="6"
            ><v-btn
              elevation="2"
              block
              prepend-icon="mdi-cash"
              color="teal-accent-1"
              @click="receiptStore.changeComponent(1), cashPay()"
              :disabled="btnNotShow()"
              >CASH</v-btn
            ></v-col
          >
          <v-col cols="6"
            ><v-btn
              elevation="2"
              block
              color="indigo-darken-4"
              prepend-icon="mdi-qrcode-scan"
              @click="receiptStore.changeComponent(2), promptpay()"
              :disabled="btnNotShow()"
              >PROMPTPAY</v-btn
            ></v-col
          >
        </v-row>
        <v-row no-gutters v-if="receiptStore.activeComponent === 1">
          <v-col cols="6"
            ><p style="text-align: center; font-size: 15px; font-weight: bold; padding-top: 16px">
              Cash: {{ receiptStore.editedReceipt.receivedAmount }} ฿
            </p></v-col
          ><v-col cols="6">
            <v-text-field
              density="compact"
              v-model="cashText"
              append-inner-icon="mdi-send"
              type="number"
              label="Insert Cash"
              @click:append-inner="calChange()"
              @keyup.enter="calChange()"
              :rules="[validateNumber]"
              clearable
              style="padding-top: 8px"
              :disabled="btnNotShow()"
            >
            </v-text-field
          ></v-col>
          <v-col cols="6" style="text-align: center; font-size: 15px; font-weight: bold"
            >Change:</v-col
          ><v-col cols="6" style="font-size: 15px; font-weight: bold"
            >{{ receiptStore.editedReceipt.change.toFixed(2) }} ฿</v-col
          >
        </v-row>
        <v-row v-if="receiptStore.activeComponent === 2">
          <v-col cols="6" style="padding-left: 60px">
            <div style="justify-content: center; align-self: center">
              <v-img
                :width="80"
                :height="80"
                aspect-ratio="1/1"
                cover
                :src="`./img/promptpay.png`"
              ></v-img>
            </div>
          </v-col>
          <v-col cols="6" align-self="center"
            >Amout: {{ receiptStore.editedReceipt.total }} ฿</v-col
          >
        </v-row>
      </v-col>

      <v-col v-else class="pa-0">
        <v-row class="align-center" no-gutters>
          <v-col cols="12">
            <v-combobox
              v-model="receiptStore.editedReceipt.branch"
              label="Select Branch"
              :items="branchStore.branchs"
              item-title="name"
              item-value="id"
              :return-object="true"
              variant="outlined"
              :disabled="btnNotShow()"
            ></v-combobox>
          </v-col>
          <v-col cols="6" style="padding-left: 60px">
            <div
              style="justify-content: center; align-self: center; padding: 0px"
              v-if="receiptStore.editedReceipt.branch"
            >
              <v-img
                :width="80"
                :height="80"
                aspect-ratio="1/1"
                cover
                :src="`./img/promptpay.png`"
              ></v-img>
            </div>
          </v-col>
          <v-col cols="6" align-self="center" v-if="receiptStore.editedReceipt.branch"
            >Amout: {{ receiptStore.editedReceipt.total }} ฿</v-col
          >
        </v-row>
      </v-col>
    </v-row>
  </v-container>
</template>
